#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/version.h>
#include <linux/time.h>
#include <linux/ip.h>
#include <net/checksum.h>
#include <linux/fs.h>
#include <asm/segment.h>
#include <asm/uaccess.h>
#include <linux/buffer_head.h>

#include <linux/kernel.h>/* We're doing kernel work */
#include <linux/proc_fs.h>/* Necessary because we use the proc fs */

/**
 *  * This structure hold information about the /proc file
 *   *
 *    */
#include <linux/netfilter_ipv4/ip_tables.h>
#include <linux/netfilter_ipv4/ipt_ALERT.h>

MODULE_AUTHOR("Edward Lin <edward730109@gmail.com>");
MODULE_DESCRIPTION("IP tables ALERT: Alert message");
MODULE_LICENSE("GPL");
#define procfs_name "Alert"
struct proc_dir_entry *Our_Proc_File;
char msg[10][20]= {0};
int count=-1;

int procfile_read(char *buffer,
	      char **buffer_location,
	      off_t offset, int buffer_length, int *eof, void *data)
{
	int ret;
	
	//printk(KERN_INFO "procfile_read (/proc/%s) called\n", procfs_name);
	
	/* 
 * 	 * We give all of our information in one go, so if the
 * 	 	 * user asks us if we have more information the
 * 	 	 	 * answer should always be no.
 * 	 	 	 	 *
 * 	 	 	 	 	 * This is important because the standard read
 * 	 	 	 	 	 	 * function from the library would continue to issue
 * 	 	 	 	 	 	 	 * the read system call until the kernel replies
 * 	 	 	 	 	 	 	 	 * that it has no more information, or until its
 * 	 	 	 	 	 	 	 	 	 * buffer is filled.
 * 	 	 	 	 	 	 	 	 	 	 */
	if (offset > 0) {
		/* we have finished to read, return 0 */
		ret  = 0;
	} else {
		/* fill the buffer, return the buffer size */
		if(count!=-1){
		ret = sprintf(buffer, msg[count]);
		count--;
		}else{ 
		ret=0;
		}
	}

	return ret;
}

/*
static
struct file* file_open(const char* path, int flags, int rights) {
	struct file* filp = NULL;
	mm_segment_t oldfs;
	int err = 0;
	printk("actual do filp_open : path : %s",path);
	filp = filp_open(path, flags, rights);	
	printk(" filp_open over");

	oldfs = get_fs();
	set_fs(get_ds());

	set_fs(oldfs);
	if(IS_ERR(filp)) {
		err = PTR_ERR(filp);
		return NULL;
	}

	return filp;
}

static
void file_close(struct file* file) {
	filp_close(file, NULL);
}

static
int file_read(struct file* file, unsigned long long offset,
		unsigned char* data, unsigned int size) {
	mm_segment_t oldfs;
	int ret;

	oldfs = get_fs();
	set_fs(get_ds());

	ret = vfs_read(file, data, size, &offset);

	set_fs(oldfs);
	return ret;
}

static
int file_write(struct file* file, unsigned long long offset,
		unsigned char* data, unsigned int size) {
	mm_segment_t oldfs;
	int ret;

	oldfs = get_fs();
	set_fs(get_ds());

	ret = vfs_write(file, data, size, &offset);

	set_fs(oldfs);
	return ret;
}

static
int file_sync(struct file* file) {
	file_fsync(file, file->f_dentry, 0);
	return 0;
}
*/
static
void setSendFlag(int id, const char *type) {
	char Filename[30];
	struct file *filp;
	char *type_tmp=(char*)type;
if(count <10){// prevent overflowa
	count++;
	if(strncmp(type, "mail", 4) == 0)
		//sprintf(Filename, "/tmp/ALERT_%d.tmp", id);
		sprintf(msg[count], "/tmp/ALERT_%d.tmp", id);
	else
		sprintf(msg[count], "/tmp/LOGALERT_%d.tmp", id);

}
/*
	printk("prepare to open file : %s \n", Filename);
	filp = file_open(Filename, O_RDWR|O_CREAT|O_EXCL|O_SYNC, 0);
	if(filp != NULL) {
		printk("Write alert file %s\n", Filename);
		file_write(filp, 0, type_tmp, strlen(type_tmp));
		file_sync(filp);
		file_close(filp);
	}
*/
}

static unsigned int
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
target(struct sk_buff **pskb,
       unsigned int hooknum,
       const struct net_device *in,
       const struct net_device *out,
       const void *targinfo,
       void *userinfo)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17)
target(struct sk_buff **pskb,
       const struct net_device *in,
       const struct net_device *out,
       unsigned int hooknum,
       const void *targinfo,
       void *userinfo)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
target(struct sk_buff **pskb,
       const struct net_device *in,
       const struct net_device *out,
       unsigned int hooknum,
       const struct xt_target *target,
       const void *targinfo,
       void *userinfo)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
target(struct sk_buff **pskb,
       const struct net_device *in,
       const struct net_device *out,
       unsigned int hooknum,
       const struct xt_target *target,
       const void *targinfo)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28)
target(struct sk_buff *skb,
       const struct net_device *in,
       const struct net_device *out,
       unsigned int hooknum,
       const struct xt_target *target,
       const void *targinfo)
#else /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,28) */
target(struct sk_buff *skb,
       const struct xt_target_param *par)
#endif
{
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28)
	const struct ipt_alert_target_info *info = targinfo;
#else
	const struct ipt_alert_target_info *info = par->targinfo;
#endif
/*
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
	struct sk_buff *skb = *pskb;
#endif
*/
/*
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
	struct iphdr *iph = ip_hdr(skb);
#else
	struct iphdr *iph = skb->nh.iph;
#endif
*/
	setSendFlag(info->id, info->type);

	return IPT_CONTINUE;
}

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
static int
checkentry(const char *tablename,
	   const struct ipt_entry *e,
	   void *targinfo,
	   unsigned int targinfosize,
	   unsigned int hook_mask)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17)
static int
checkentry(const char *tablename,
	   const void *e,
	   void *targinfo,
	   unsigned int targinfosize,
	   unsigned int hook_mask)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
static int
checkentry(const char *tablename,
	   const void *e,
	   const struct xt_target *target,
	   void *targinfo,
	   unsigned int targinfosize,
	   unsigned int hook_mask)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)
static int
checkentry(const char *tablename,
	   const void *e,
	   const struct xt_target *target,
	   void *targinfo,
	   unsigned int hook_mask)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28)
static bool
checkentry(const char *tablename,
	   const void *e,
	   const struct xt_target *target,
	   void *targinfo,
	   unsigned int hook_mask)
#else /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,28) */
static bool
checkentry(const struct xt_tgchk_param *par)
#endif
{
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,28)
	const char *tablename = par->table;
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17)
	if (targinfosize != IPT_ALIGN(sizeof(struct ipt_alert_target_info))) {
		printk(KERN_WARNING "ALERT: targinfosize %u != %Zu\n",
		       targinfosize,
		       IPT_ALIGN(sizeof(struct ipt_alert_target_info)));
		return 0;
	}
#endif

	//struct ipt_entry *entry = (struct ipt_entry *)e;
	//struct ipt_ip ip = entry->ip;

	//struct ipt_entry_match *e_match = (struct ipt_entry_match *)(entry->elems);
	//struct ipt_match *match = (struct ipt_match *)(e_match->u.kernel.match);

	if (strcmp(tablename, "mangle") != 0) {
		printk(KERN_WARNING "ALERT: can only be called from \"mangle\" table, not \"%s\"\n", tablename);
		return 0;
	}

#if LINUX_VERSION_CODE == KERNEL_VERSION(2,6,36)
    return 0;
#else
    return 1;
#endif

}

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,21)
static struct xt_target ipt_alert_reg = {
#else
static struct ipt_target ipt_alert_reg = { 
#endif
	.name		= "ALERT",
#if LINUX_VERSION_CODE == KERNEL_VERSION(2,6,36)
	.family     = NFPROTO_IPV4,
#else
	.family		= AF_INET,
#endif
	.target		= target,
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,17)
	.targetsize	= sizeof(struct ipt_alert_target_info),
#endif
	.checkentry	= checkentry,
	.me		= THIS_MODULE
};

static int __init init(void)
{

	Our_Proc_File = create_proc_entry(procfs_name, 0644, NULL);
	
	if (Our_Proc_File == NULL) {
		remove_proc_entry(procfs_name, &proc_root);
		printk(KERN_ALERT "Error: Could not initialize /proc/%s\n",
		       procfs_name);
		return -ENOMEM;
	}

	Our_Proc_File->read_proc = procfile_read;
//	Our_Proc_File->owner 	 = THIS_MODULE;
	Our_Proc_File->mode 	 = S_IFREG | S_IRUGO;
	Our_Proc_File->uid 	 = 0;
	Our_Proc_File->gid 	 = 0;
	Our_Proc_File->size 	 = 37;

	printk(KERN_INFO "/proc/%s created\n", procfs_name);

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,21)
	return xt_register_target(&ipt_alert_reg);
#else
	return ipt_register_target(&ipt_alert_reg);
#endif
}

static void __exit fini(void)
{

	remove_proc_entry(procfs_name, &proc_root);
	printk(KERN_INFO "/proc/%s removed\n", procfs_name);

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,21)
	xt_unregister_target(&ipt_alert_reg);
#else
	ipt_unregister_target(&ipt_alert_reg);
#endif
}

module_init(init);
module_exit(fini);
