/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "group3g.h"
#include <config.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <asm/fcntl.h>
#include <unistd.h>
#include <termios.h>

int send_AT_command(char *dev,char *cmd,char *result,int t_s,int t_us);
/* 
 * group3g_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
/*
 * init_group3g():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_group3g(void) {

	printf("%s,%d\n",__FUNCTION__,__LINE__);
	#ifdef SNMP_CUSTOMER_ID //netcom
	   //#error 11
       oid group3g_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,23 };
    #else                    //amit
	   //#error 00
       oid group3g_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,23 }; 
    #endif
	//oid group3g_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,23 };
	//oid group3g_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,23 };
	struct variable2 group3g_variables[] = {
		/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
		{ SIGNAL3G            , ASN_INTEGER    , RONLY , var_group3g, 1, { 1 } },
		{ WAN3GTRAFFICIN      , ASN_INTEGER    , RONLY , var_group3g, 1, { 2 } },
		{ WAN3GTRAFFICOUT     , ASN_INTEGER    , RONLY , var_group3g, 1, { 3 } },
	};
	
	REGISTER_MIB("gateway/group3g", group3g_variables, variable2,group3g_variables_oid);
  /* place any other initialization junk you need here */
}


/*
 * var_group3g():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
static char buff[BUFFSIZE];

unsigned char *
var_group3g(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case WAN3GTRAFFICOUT:
		{
			unsigned long i1,i2,i3,i4;
        	int devfd;
			i1=i2=i3=i4=0;
			
			devfd=open("/proc/net/dev", O_RDONLY,0);
			if(devfd!=-1)
			{
				char *b;
				memset(buff,0,BUFFSIZE);
			    read(devfd,buff,BUFFSIZE-1);
			    close(devfd);				
				b=strstr(buff,"ppp0:");
				if(b>0)
				{
					sscanf(b, "ppp0:%lu %lu %*u %*u %*u %*u %*u %*u %lu %lu %*u %*u %*u %*u %*u %*u\n",&i1,&i2,&i3,&i4);
				}
			}
			printf("i1=%lu,i2=%lu,i3=%lu,i4=%lu\n", i1,i2,i3,i4);
        	long_ret = i1;
	        return (unsigned char *) &long_ret;  
		}
        


    case WAN3GTRAFFICIN:
		{
			unsigned long i1,i2,i3,i4;
        	int devfd;
			i1=i2=i3=i4=0;
			
			devfd=open("/proc/net/dev", O_RDONLY,0);
			if(devfd!=-1)
			{
				char *b;
				memset(buff,0,BUFFSIZE);
			    read(devfd,buff,BUFFSIZE-1);
			    close(devfd);				
				b=strstr(buff,"ppp0:");
				if(b>0)
				{
					sscanf(b, "ppp0:%lu %lu %*u %*u %*u %*u %*u %*u %lu %lu %*u %*u %*u %*u %*u %*u\n",&i1,&i2,&i3,&i4);
				}
			}
			printf("i1=%lu,i2=%lu,i3=%lu,i4=%lu\n", i1,i2,i3,i4);
        	long_ret = i3;
	        return (unsigned char *) &long_ret;  
		}
        


    case SIGNAL3G:
		{
		    char result[MAX_AT_CMD_LEN+1];
		    int rssi,ret=-1;
			char *p;
			FILE *f;

			memset(result,0,sizeof(result));
		if(send_AT_command("/dev/modem2","AT+CSQ\r",result,1,0)!=-1)
		{
			if((p=strstr(result,"CSQ:"))!=NULL)
			{
				sscanf(p,"CSQ: %d,",&rssi);
				printf("rssi=%d\n",rssi);
				long_ret = (rssi*100)/31;
			}
			else if((p=strstr(result,"ERROR"))!=NULL)
			{	
				long_ret = 0;
//				write_csman(csman_fd, CSID_S_3G_SIGNAL_STRENGTH, &rssi, sizeof(int), 0);
			}
		}
//        long_ret = rssi;
        return (unsigned char *) &long_ret;
		}
        



    default:
      ERROR_MSG("");
  }
  return NULL;
}


int atcmd_lock()
{
	if(access("/tmp/atcmd_lock",R_OK) == 0)
	{	
		return 1;
	}
	else
	{
		system("touch /tmp/atcmd_lock");
		return 0;
	}
}

void atcmd_unlock()	
{
//	syslog(LOG_INFO,"Try to delete hotplug_lock");
	remove("/tmp/atcmd_lock");	
}

int send_AT_command(char *dev,char *cmd,char *result,int t_s,int t_us)
{
	int fd,n,i,res_len=0,flag,try_again=1;
	unsigned short cflag_brate = B57600;
	struct termios oldtio,newtio;
	fd_set fds;
	struct timeval tv;
	short ind = 0;
	printf("send AT command: %s\n",cmd);
	//just lock modem2, because it is a query interface in FW
	//add by Laroche 2009/04/06
	if ((strcmp(dev,"/dev/modem2") == 0) || (strcmp(dev,"/dev/ttyIPWp8") == 0))
	{
AT_RETRY:
		if (atcmd_lock())
		{
			ind ++;
			sleep(1);
			if (ind < 5)
			{
				goto AT_RETRY;
			}
		}
	}
	
	if((fd=open(dev,O_RDWR| O_NDELAY)) ==-1) 
	{
		printf("Can't open %s\n",dev);
		if ((strcmp(dev,"/dev/modem2") == 0) || (strcmp(dev,"/dev/ttyIPWp8") == 0))
		{
			atcmd_unlock();
		}
		return -1;
	}
	
   	//memset(result, 0, sizeof(result));
	tcgetattr(fd,&oldtio);

retry:
	bzero(&newtio,sizeof(newtio));
	newtio.c_cflag = cflag_brate | CRTSCTS | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;
	newtio.c_lflag = ICANON;
	tcflush(fd,TCIFLUSH);
	tcsetattr(fd,TCSANOW,&newtio);
	
	flag = fcntl(fd,F_GETFL);
	//fcntl(fd,F_SETFL,flag | FNDELAY);
	fcntl(fd,F_SETFL,flag | O_NDELAY);
	
	n = write(fd,cmd,strlen(cmd));
	if(n>0)
	{
		while(1)
		{
			tv.tv_sec = t_s;
			tv.tv_usec =t_us;
			FD_ZERO(&fds);
			FD_SET(fd,&fds);
			if((i=select(fd+1,&fds,NULL,NULL,&tv))==-1) break;
			else if(i==0) break;
			else if(FD_ISSET(fd,&fds))
			{
				n = read(fd,result+res_len,(MAX_AT_CMD_LEN-1-res_len));				
				if(n<=0) break;
				if(n+res_len >=(MAX_AT_CMD_LEN-1)) break;
				res_len+=n;
			}
		}
	}
	else if(n<0)
	{
		res_len = -1;
		goto end;
	}
	if(res_len ==0 && try_again)
	{
		cflag_brate = B115200; /* No response,baud rateAtry@ */
		try_again = 0;
		goto retry;
	}
end:
#ifdef _ATCMD_LOG
	syslog(LOG_INFO,"Send AT command [%s] and get result [%s]",cmd,result);
#endif
	fcntl(fd,F_SETFL,flag);
	tcsetattr(fd,TCSANOW,&oldtio);
	close(fd);
	//if (!strcmp(dev,"/dev/modem2"))
	if ((strcmp(dev,"/dev/modem2") == 0) || (strcmp(dev,"/dev/ttyIPWp8") == 0))
	{
		atcmd_unlock();
	}
	return res_len;
}





