/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "sagroup.h"
#include "csman.h"


static unsigned char vsindex;
/* 
 * sagroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
  //#error 11
  oid sagroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,13 };     
#else                    //amit
  //#error 00
  oid sagroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,13 };     
#endif

//oid sagroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,13 };
//oid sagroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,13 };


/* 
 * variable4 sagroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the sagroup mib section 
 */


struct variable4 sagroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { SATRIGGEROBPORT     , ASN_OCTET_STR   , RWRITE, var_sATable, 3, { 1,1,1 } },
  { SAIBLISTPORTS       , ASN_OCTET_STR , RWRITE, var_sATable, 3, { 1,1,2 } },
  { SARULESWITCH        , ASN_INTEGER   , RWRITE, var_sATable, 3, { 1,1,3 } },
  { SAINDEX             , ASN_INTEGER   , RWRITE, var_sATable, 3, { 1,1,4 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_sagroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_sagroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/sagroup", sagroup_variables, variable4,
               sagroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_sagroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_sagroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {



    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_sATable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_sagroup above.
 */
unsigned char *
var_sATable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case SAINDEX:
		{
			*write_method = write_sAindex;
			long_ret = vsindex;
			return (unsigned char *) &long_ret;
		}

    case SARULESWITCH:
		{ 
			*write_method = write_sARuleSwitch;
			int ret = 0;
			int fd=0;
			unsigned char rule_switch;
			ret = read_csman(fd,0x00170001+vsindex,&rule_switch,sizeof(unsigned char),TYPE_U32);
			long_ret =  rule_switch;
			return (unsigned char *) &long_ret;
		}

    case SAIBLISTPORTS:
		{
			*write_method = write_sAIBlistPorts;
			int ret = 0;
			int fd=0;
			unsigned char incoming_port[512];
			
			memset(incoming_port,0,sizeof(incoming_port));
			ret = read_csman(fd,0x00170021+vsindex,incoming_port,sizeof(incoming_port),TYPE_STR);
	
			strcpy(string,incoming_port);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SATRIGGEROBPORT:
		{
			*write_method = write_sATriggerOBport;
			int ret = 0;
			int fd=0;
			unsigned char trigger_port[512];
			
			memset(trigger_port,0,sizeof(trigger_port));
			ret = read_csman(fd,0x00170011+vsindex,trigger_port,sizeof(trigger_port),TYPE_STR);
	
			strcpy(string,trigger_port);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_sAindex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sAindex not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sAindex: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  vsindex = long_ret;
			  printf("vsindex = %d\n",vsindex);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sARuleSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sARuleSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sARuleSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00170001+vsindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sAIBlistPorts(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sAIBlistPorts not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sAIBlistPorts: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00170021+vsindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sATriggerOBport(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sATriggerOBport not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sATriggerOBport: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00170011+vsindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






