/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "svgroup.h"
#include "csman.h"


/* 
 * svgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
   //#error 11
   oid svgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,25 };    
#else                    //amit
   //#error 00
   oid svgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,25 };    
#endif

//oid svgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,25 };
//oid svgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,25 };


/* 
 * variable2 svgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the svgroup mib section 
 */


struct variable2 svgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { DHCPSERVER          , ASN_INTEGER , RONLY , var_svgroup, 1, { 1 } },
  { VIRTUALSERVER       , ASN_INTEGER , RONLY , var_svgroup, 1, { 2 } },
  { SPECIAIAP           , ASN_INTEGER , RONLY , var_svgroup, 1, { 3 } },
  { DMZ                 , ASN_INTEGER , RONLY , var_svgroup, 1, { 4 } },
  { UPNP                , ASN_INTEGER , RONLY , var_svgroup, 1, { 5 } },
  { PACKETFILTER        , ASN_INTEGER , RONLY , var_svgroup, 1, { 6 } },
  { DOMAINFILTER        , ASN_INTEGER , RONLY , var_svgroup, 1, { 7 } },
  { URLBLOCKING         , ASN_INTEGER , RONLY , var_svgroup, 1, { 8 } },
  { MACCONTROL          , ASN_INTEGER , RONLY , var_svgroup, 1, { 9 } },
  { QOS                 , ASN_INTEGER , RONLY , var_svgroup, 1, { 10 } },
  { RIP                 , ASN_OCTET_STR , RONLY , var_svgroup, 1, { 11 } },
  { SCHEDULING          , ASN_INTEGER , RONLY , var_svgroup, 1, { 12 } },
  { PPTPSERVER          , ASN_INTEGER , RONLY , var_svgroup, 1, { 13 } },
  { L2TPSERVER          , ASN_INTEGER , RONLY , var_svgroup, 1, { 14 } },
  { IPSEC               , ASN_INTEGER , RONLY , var_svgroup, 1, { 15 } },
  { SMB                 , ASN_INTEGER , RONLY , var_svgroup, 1, { 16 } },
  { FTPSERVER           , ASN_INTEGER , RONLY , var_svgroup, 1, { 17 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_svgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_svgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/svgroup", svgroup_variables, variable2,
               svgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_svgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_svgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case FTPSERVER:
		{
			int ret = 0;
			int fd=0;
			unsigned int dhcp_leasetime = 0;
			ret = read_csman(fd,0x00030002,&dhcp_leasetime,sizeof(unsigned int),TYPE_U32);
			printf("dhcp_leasetime = %d\n",dhcp_leasetime);
			long_ret = dhcp_leasetime;
			long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case SMB:
		{
			int ret = 0;
			int fd=0;
			unsigned int dhcp_leasetime = 0;
			ret = read_csman(fd,0x00030002,&dhcp_leasetime,sizeof(unsigned int),TYPE_U32);
			printf("dhcp_leasetime = %d\n",dhcp_leasetime);
			long_ret = dhcp_leasetime;
			long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case IPSEC:
		{
			int ret = 0;
			int fd=0;
			unsigned int dhcp_leasetime = 0;
			ret = read_csman(fd,0x00030002,&dhcp_leasetime,sizeof(unsigned int),TYPE_U32);
			printf("dhcp_leasetime = %d\n",dhcp_leasetime);
			long_ret = dhcp_leasetime;
			long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case L2TPSERVER:
		{
			int ret = 0;
			int fd=0;
			unsigned int dhcp_leasetime = 0;
			ret = read_csman(fd,0x00030002,&dhcp_leasetime,sizeof(unsigned int),TYPE_U32);
			printf("dhcp_leasetime = %d\n",dhcp_leasetime);
			long_ret = dhcp_leasetime;
			long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case PPTPSERVER:
		{
			int ret = 0;
			int fd=0;
			unsigned int dhcp_leasetime = 0;
			ret = read_csman(fd,0x00030002,&dhcp_leasetime,sizeof(unsigned int),TYPE_U32);
			printf("dhcp_leasetime = %d\n",dhcp_leasetime);
			long_ret = dhcp_leasetime;
			long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case SCHEDULING:
		{
			int ret = 0;
			int fd=0;
			unsigned int sch_enable = 0;
			ret = read_csman(fd,0x000b0001,&sch_enable,sizeof(unsigned int),TYPE_U32);
			printf("sch_enable = %d\n",sch_enable);
			long_ret = sch_enable;
	        return (unsigned char *) &long_ret;  
		}

    case RIP:
		{
			int ret = 0;
			int fd=0;
			unsigned int rip = 0;
			ret = read_csman(fd,0x00130001,&rip,sizeof(unsigned int),TYPE_U32);

			printf("rip = %d\n",rip);
			if(rip == 0)
				sprintf(string,"Disable");
			else if(rip == 1)
				sprintf(string,"RIPv1");
			else if(rip == 2)
				sprintf(string,"RIPv2");
			
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case QOS:
		{
			int ret = 0;
			int fd=0;
			unsigned int qos_enable = 0;
			ret = read_csman(fd,0x00120001,&qos_enable,sizeof(unsigned int),TYPE_U32);
			printf("qos_enable = %d\n",qos_enable);
			long_ret = qos_enable;
	        return (unsigned char *) &long_ret;  
		}

    case MACCONTROL:
		{
			int ret = 0;
			int fd=0;
			unsigned int macctl_enable = 0;
			ret = read_csman(fd,0x000d0001,&macctl_enable,sizeof(unsigned int),TYPE_U32);
			printf("macctl_enable = %d\n",macctl_enable);
			long_ret = macctl_enable;
	        return (unsigned char *) &long_ret;  
		}

    case URLBLOCKING:
		{
			int ret = 0;
			int fd=0;
			unsigned int urlblock_enable = 0;
			ret = read_csman(fd,0x00100001,&urlblock_enable,sizeof(unsigned int),TYPE_U32);
			printf("urlblock_enable = %d\n",urlblock_enable);
			long_ret = urlblock_enable;
	        return (unsigned char *) &long_ret;  
		}

    case DOMAINFILTER:
		{
			int ret = 0;
			int fd=0;
			unsigned int dmfilter_enable = 0;
			ret = read_csman(fd,0x000f0001,&dmfilter_enable,sizeof(unsigned int),TYPE_U32);
			printf("dmfilter_enable = %d\n",dmfilter_enable);
			long_ret = dmfilter_enable;
	        return (unsigned char *) &long_ret;  
		}

    case PACKETFILTER:
		{
			int ret = 0;
			int fd=0;
			unsigned int pktfilter_out_enable = 0;
			unsigned int pktfilter_in_enable = 0;
			ret = read_csman(fd,0x000e0001,&pktfilter_out_enable,sizeof(unsigned int),TYPE_U32);
			ret = read_csman(fd,0x000e0002,&pktfilter_in_enable,sizeof(unsigned int),TYPE_U32);
			printf("pktfilter_out_enable = %d\n",pktfilter_out_enable);
			printf("pktfilter_in_enable = %d\n",pktfilter_in_enable);
			if(pktfilter_out_enable||pktfilter_in_enable)
				long_ret = 1;
			else 
				long_ret = 0;
	        return (unsigned char *) &long_ret;  
		}

    case UPNP:
		{
			int ret = 0;
			int fd=0;
			unsigned int upnp_enable = 0;
			ret = read_csman(fd,0x0015000b,&upnp_enable,sizeof(unsigned int),TYPE_U32);
			printf("upnp_enable = %d\n",upnp_enable);
			long_ret = upnp_enable;
	        return (unsigned char *) &long_ret;  
		}  

    case DMZ:
		{
			int ret = 0;
			int fd=0;
			unsigned int dmz_enable = 0;
			ret = read_csman(fd,0x00150008,&dmz_enable,sizeof(unsigned int),TYPE_U32);
			printf("dmz_enable = %d\n",dmz_enable);
			long_ret = dmz_enable;
	        return (unsigned char *) &long_ret;  
		}

    case SPECIAIAP:
		{
			int ret = 0;
			int fd=0;
			int i=0;
			unsigned int specialap_enable = 0;
			for(i=0;i<8;i++)
			{
				ret = read_csman(fd,0x00170001+i,&specialap_enable,sizeof(unsigned int),TYPE_U32);
				if(specialap_enable == 1)
				{
					long_ret = 1;
					return (unsigned char *) &long_ret;
				}
			}	
	        return (unsigned char *) &long_ret;  
		}

    case VIRTUALSERVER:
		{
			int ret = 0;
			int fd=0;
			int i=0;
			long_ret = 0;
			unsigned int virtualserver_enable = 0;
			for(i=0;i<8;i++)
			{
				ret = read_csman(fd,0x000c1000+i,&virtualserver_enable,sizeof(unsigned int),TYPE_U32);
				if(virtualserver_enable == 1)
				{
					printf("i=%d\n",i);
					long_ret = 1;
					return (unsigned char *) &long_ret;
				}
			}
	        return (unsigned char *) &long_ret;  
		}

    case DHCPSERVER:
		{
			
			int ret = 0;
			int fd=0;
			int dhcp_enable;
			ret = read_csman(fd,0x00030001,&dhcp_enable,sizeof(unsigned char),TYPE_U32);
			printf("dhcp_enable = %u\n",dhcp_enable);
			long_ret = dhcp_enable;
	        return (unsigned char *) &long_ret;  
		}

    default:
      ERROR_MSG("");
  }
  return NULL;
}







