/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "IPv4SystemStatus.h"
#include "csman.h"

/* 
 * IPv4SystemStatus_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
oid IPv4SystemStatus_variables_oid[] = { 1,3,6,1,4,1,851,2,3,9,1,1,1 };
//     #error 11
        
#else                    //amit
oid IPv4SystemStatus_variables_oid[] = { 1,3,6,1,4,1,12823,2,3,9,1,1,1 };
  //          #error 00
               
#endif

/* 
 * variable7 IPv4SystemStatus_variables:
 *   this variable defines function callbacks and type return information 
 *   for the IPv4SystemStatus mib section 
 */

struct variable7 IPv4SystemStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{STAT4WANTYPE,  ASN_INTEGER,  RONLY ,  var_IPv4SystemStatus, 1,  { 1 }},
{STAT4IPADDRESS,  ASN_IPADDRESS,  RONLY ,  var_IPv4SystemStatus, 1,  { 2 }},
{STAT4SUBNETMASK,  ASN_IPADDRESS,  RONLY ,  var_IPv4SystemStatus, 1,  { 3 }},
{STAT4GATEWAY,  ASN_IPADDRESS,  RONLY ,  var_IPv4SystemStatus, 1,  { 4 }},
{STAT4DNS1,  ASN_IPADDRESS,  RONLY ,  var_IPv4SystemStatus, 1,  { 5 }},
{STAT4DNS2,  ASN_IPADDRESS,  RONLY ,  var_IPv4SystemStatus, 1,  { 6 }},
{STAT4MACADDRESS,  ASN_OCTET_STR,  RONLY,   var_IPv4SystemStatus, 1,  { 7 }},
{STAT4REMAINLEASETIME,  ASN_INTEGER,  RONLY ,  var_IPv4SystemStatus, 1,  { 8 }},
{STAT4CONNECTIONTIME,  ASN_INTEGER,  RONLY ,  var_IPv4SystemStatus, 1,  { 9 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the IPv4SystemStatus module */
void
init_IPv4SystemStatus(void)
{

    DEBUGMSGTL(("IPv4SystemStatus", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("IPv4SystemStatus", IPv4SystemStatus_variables, variable7,
               IPv4SystemStatus_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_IPv4SystemStatus():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_IPv4SystemStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case STAT4WANTYPE:
		{
			unsigned int wan_type;
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);

			if(wan_type == LOCAL_WANTYPE_DHCP) //dynamic
				long_ret = 0;
			else if(wan_type == LOCAL_WANTYPE_FIXED) //static
				long_ret = 1;
			else if(wan_type == LOCAL_WANTYPE_PPPOE) //PPPoE
				long_ret = 2;
			else if(wan_type == LOCAL_WANTYPE_PPTP) //pptp
				long_ret = 3;
			else if(wan_type == LOCAL_WANTYPE_L2TP) //l2tp
				long_ret = 4;
			else if(wan_type == LOCAL_WANTYPE_3G) //3G
				long_ret = 5;
			else if(wan_type == LOCAL_WANTYPE_IBURST) //iBurst
				long_ret = 6;

			//long_ret = wan_type;
	        return (unsigned char *) &long_ret;
		}
    case STAT4IPADDRESS:
		{
			unsigned char wan_ip[4];
			unsigned int wan_type;
			*string = 0;
			
			memset(wan_ip,0,sizeof(wan_ip));
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);

			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035002,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				read_csman(fd,0x00110001,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x80040200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340200,wan_ip,sizeof(wan_ip),TYPE_IPV4);

			*var_len = 4; //IP address length = 4
			return (unsigned char *) wan_ip;
		}
    case STAT4SUBNETMASK:
		{
			unsigned char wan_subnet[4];
			unsigned int wan_type;

			memset(wan_subnet,0,sizeof(wan_subnet));
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035003,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				read_csman(fd,0x00110002,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x80040300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);

			*var_len = 4; //IP address length = 4
			return (unsigned char *) wan_subnet;
		}
    case STAT4GATEWAY:
		{
			unsigned char wan_gateway[4];
			unsigned int wan_type;

			memset(wan_gateway,0,sizeof(wan_gateway));
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035004,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				read_csman(fd,0x00110003,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x80040400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);

			*var_len = 4; //IP address length = 4
			return (unsigned char *) wan_gateway;
		}
    case STAT4DNS1:
		{
			unsigned char wan_prim_dns[4];
			unsigned int wan_type;

			memset(wan_prim_dns,0,sizeof(wan_prim_dns));
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035005,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				read_csman(fd,0x00110004,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x00040700,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050500,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060500,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0500,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340500,wan_prim_dns,sizeof(wan_prim_dns),TYPE_IPV4);

			*var_len = 4; //IP address length = 4
			return (unsigned char *) wan_prim_dns;
		}
    case STAT4DNS2:
		{

			unsigned char wan_second_dns[4];
			unsigned int wan_type;

			memset(wan_second_dns,0,sizeof(wan_second_dns));
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035006,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				read_csman(fd,0x00110005,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x00040800,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050600,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060600,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0600,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340600,wan_second_dns,sizeof(wan_second_dns),TYPE_IPV4);

			*var_len = 4; //IP address length = 4
			return (unsigned char *) wan_second_dns;
		}
    case STAT4MACADDRESS:
		{
			static char stat_mac[6];
			memset(stat_mac,0,sizeof(stat_mac));
			read_csman(fd,0x8000f371,stat_mac,sizeof(stat_mac),TYPE_MAC);
			*var_len = sizeof(stat_mac);
			return (unsigned char *) stat_mac;
		}
    case STAT4REMAINLEASETIME:
		{
			unsigned int remain_lease_time;
			unsigned int wan_type;
			
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_FIXED)
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_PPPOE)
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_PPTP)
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_L2TP)
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_3G
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_IBURST)
			//	read_csman(fd,0x80035009,&remain_lease_time,sizeof(unsigned int),TYPE_U32);
			else
				remain_lease_time = 0;

			long_ret = remain_lease_time;
	        return (unsigned char *) &long_ret;
		}
    case STAT4CONNECTIONTIME:
		{
			unsigned int connection_time;
			unsigned int wan_type;
			
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				read_csman(fd,0x80035010,&connection_time,sizeof(unsigned int),TYPE_U32);
			//else if(wan_type == LOCAL_WANTYPE_FIXED)
			//	read_csman(fd,0x80035010,&connection_time,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				read_csman(fd,0x80040100,&connection_time,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				read_csman(fd,0x80050100,&connection_time,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				read_csman(fd,0x80060100,&connection_time,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_3G)
				read_csman(fd,0x801e0100,&connection_time,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				read_csman(fd,0x80340100,&connection_time,sizeof(unsigned int),TYPE_U32);
			else
				connection_time = 0;

			long_ret = connection_time;
	        return (unsigned char *) &long_ret;
		}
    default:
      ERROR_MSG("");
    }
    return NULL;
}




