/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "AdvMACControl.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>


#define NUM_MACCONTROL	100
int mac_w_index=0;

/* 
 * AdvMACControl_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid AdvMACControl_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,3,1,4 };

/* 
 * variable4 AdvMACControl_variables:
 *   this variable defines function callbacks and type return information 
 *   for the AdvMACControl mib section 
 */

struct variable7 AdvMACControl_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVMACCONTROLENABLE,  ASN_INTEGER,  RWRITE, var_AdvMACControl, 1,  { 1 }},
{ADVMACCONTROLBLACKORWHITELIST,  ASN_INTEGER,  RWRITE, var_AdvMACControl, 1,  { 2 }},
{ADVMACCONTROLLOGALERT,  ASN_INTEGER,  RWRITE, var_AdvMACControl, 1,  { 3 }},
{ADVMACCONTROLACENABLE,  ASN_INTEGER,  RWRITE,var_AdvMACControl, 1,  { 4 }},
{ADVMACCONTROLACALLOWDENY,  ASN_INTEGER,  RWRITE,var_AdvMACControl, 1,  { 5 }},

{ADVMACIDINDEX,  ASN_INTEGER,  RONLY,var_AdvMACControlTable, 3,  { 6 , 1, 1 }},
{ADVMACADDRESSLIST,  ASN_OCTET_STR,  RWRITE,var_AdvMACControlTable, 3,  { 6 , 1, 2 }},
{ADVMACIDCENABLE,  ASN_INTEGER,  RWRITE,var_AdvMACControlTable, 3,  { 6 , 1, 3 }},
{ADVMACIDAENABLE,  ASN_INTEGER,  RWRITE,var_AdvMACControlTable, 3,  { 6 , 1, 4 }},
{ADVMACIDRULEENABLE,  ASN_INTEGER,  RWRITE,var_AdvMACControlTable, 3,  { 6 , 1, 5 }},
{ADVMACIDSCHEDULE,  ASN_INTEGER,  RWRITE,var_AdvMACControlTable, 3,  { 6 , 1, 6 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the AdvMACControl module */
void
init_AdvMACControl(void)
{

    DEBUGMSGTL(("AdvMACControl", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("AdvMACControl", AdvMACControl_variables, variable7,
               AdvMACControl_variables_oid);

    /* place any other initialization junk you need here */
}


static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#define IFENTRY_NAME_LENGTH     16
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}


/*
 * var_AdvMACControl():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_AdvMACControl(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVMACCONTROLENABLE:
        *write_method = write_AdvMACControlEnable;
	read_csman(fd,0x000d0001,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVMACCONTROLBLACKORWHITELIST:
        *write_method = write_AdvMACControlBlackorWhiteList;
	read_csman(fd,0x000d0003 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVMACCONTROLLOGALERT:
        *write_method = write_AdvMACControlLogAlert;
	read_csman(fd,0x000d0007 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVMACCONTROLACENABLE:
        *write_method = write_AdvMACControlACEnable;
	read_csman(fd,0x000d0004 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVMACCONTROLACALLOWDENY:
        *write_method = write_AdvMACControlACAllowDeny;
	read_csman(fd,0x000d0005 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_AdvMACControlTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_AdvMACControl above.
 */
unsigned char *
var_AdvMACControlTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_MACCONTROL);
    mac_w_index=index;

    if ( index == MATCH_FAILED )
        return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVMACIDINDEX:
        long_ret = index;
      	return (unsigned int *) &long_ret;
    case ADVMACADDRESSLIST:
        *write_method = write_AdvmacAddressList;
	 memset(string,0,sizeof(string));
        read_csman(fd,0x000d0100+index-1,string,sizeof(string),TYPE_MAC);
        *var_len = 6;
        return (unsigned char *) string;
    case ADVMACIDCENABLE:
        *write_method = write_AdvmacIdCEnable;
      	 read_csman(fd, 0x000d0300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
        return (unsigned char *) &long_ret;
    case ADVMACIDAENABLE:
        *write_method = write_AdvmacIdAEnable;
      	 read_csman(fd, 0x000d0400+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
        return (unsigned char *) &long_ret;
    case ADVMACIDRULEENABLE:
        *write_method = write_AdvmacIdRuleEnable;
        read_csman(fd, 0x000d0800+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
        return (unsigned char *) &long_ret;
    case ADVMACIDSCHEDULE:
        *write_method = write_AdvmacIdSchedule;
    	 read_csman(fd, 0x000d0600 +index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
        return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_AdvMACControlEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    int fd=0;
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
	   long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             	  write_csman(fd,0x000d0001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
         	   write_csman(fd,0x000d0002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
         	   write_csman(fd,0x000d0008,&long_ret,sizeof(unsigned int) ,TYPE_U32);
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvMACControlBlackorWhiteList(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
                    	int i,value=0,fd=0;
               	write_csman(fd,0x000d0003,&long_ret,sizeof(unsigned int) ,TYPE_U32);

           		read_csman(fd,0x000d0003,&value,sizeof(unsigned int) ,TYPE_U32);

           	 	if(value == 0)
           		{
                		for(i=0;i<=128;i++)
                		{
                    			write_csman(fd,0x000d0300+i,&value,sizeof(unsigned int) ,TYPE_U32);
                		}
            		}
            		else
            		{
                		for(i=0;i<=128;i++)
                		{
                    			write_csman(fd,0x000d0300+i,&value,sizeof(unsigned int) ,TYPE_U32);
                		}
            		}
			  break;
                }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvMACControlLogAlert(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
                    	int fd=0;
                	write_csman(fd,0x000d0007,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            		break;
           }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvMACControlACEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    int fd=0;
    static unsigned long long_ret;;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
            	  write_csman(fd,0x000d0004,&long_ret,sizeof(unsigned int) ,TYPE_U32);
                break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvMACControlACAllowDeny(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    int fd=0;
    static unsigned long long_ret;;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
            	  write_csman(fd,0x000d0005,&long_ret,sizeof(unsigned int) ,TYPE_U32);
                break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvmacAddressList(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to AdvMACControl not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
              //for STR/MAC data type
              memset(string,0,sizeof(string));
              strncpy(string , (char *) var_val, var_val_len);
              break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd;
              write_csman(fd,0x000d0100+mac_w_index-1,string,strlen(string) ,TYPE_MAC);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvmacIdCEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
            	int deny_value=0;
              int fd=0;
        	read_csman(fd,0x000d0003,&deny_value,sizeof(unsigned int) ,TYPE_U32);

              write_csman(fd,0x000d0300 +mac_w_index-1,&deny_value,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvmacIdAEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
   static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
            long_ret = *(unsigned int *) var_val;
            break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
           	int deny_value=0;
              int fd=0;
       	 read_csman(fd,0x000d0005,&deny_value,sizeof(unsigned int) ,TYPE_U32);

              write_csman(fd,0x000d0400 +mac_w_index-1,&deny_value,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvmacIdRuleEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
   static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
            long_ret = *(unsigned int *) var_val;
            break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
              int fd=0;
              write_csman(fd,0x000d0800 +mac_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvmacIdSchedule(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvMACControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvMACControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
            long_ret = *(unsigned int *) var_val;
            break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x000d0600 +mac_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
