
#You can modify it for your compiler

include $(ROOTDIR)/project_config/project.instcomp

CC = $(CROSS_COMPILE)cc
LD = $(CROSS_COMPILE)ld
STRIP = $(CROSS_COMPILE)strip
LDFLAGS = -s

#LIBPATH= -L../../../../$(TARGET_PREFIX)lib -L../../../../../$(TARGET_PREFIX)lib
#LIBPATH= -L../../../../$(TARGET_PREFIX)lib -L../../../../../$(TARGET_PREFIX)lib -L../../../../../../$(TARGET_PREFIX)lib
LIBPATH= -L../../../../../../$(TARGET_PREFIX)lib -L../../../../../../../$(TARGET_PREFIX)lib -L../../../../../../../../$(TARGET_PREFIX)lib
DEFS    = -D_KERNEL_
ifeq (${PROJECT_NAME}, ${filter ${PROJECT_NAME}, CDE77ADL_001 })
  ifdef PRJ_INSTALL_OOpenssl_101c
#      DEFS += -DUSE_SSL 
  endif
else
  ifdef PRJ_INSTALL_OOpenssl_100b3
#    DEFS += -DUSE_SSL 
  endif
endif

#INCLUDE = -I/usr/src/linux-2.4.20-8/include -I/usr/kerberos/include

#INCLUDE = -I$(KERNEL_DIR)/include -I/usr/kerberos/include -I ../../../../../include -I ../../../../../../include
#INCLUDE = -I../../../include -I../../../../include -I../../../../../include -I../../../../../../include
INCLUDE = -I../../../../../include -I../../../../../../include -I../../../../../../../include -I../../../../../../../../include
LDLIBS  = $(LIBPATH) -lpthread -ldl -lcsman
ifeq (${PROJECT_NAME}, ${filter ${PROJECT_NAME}, CDE77ADL_001 })
  ifdef PRJ_INSTALL_OOpenssl_101c
      LDLIBS += -lssl -lcrypto
  endif
else
  ifdef PRJ_INSTALL_OOpenssl_100b3
      LDLIBS += -lssl -lcrypto
  endif
endif
CFLAGS += -Wall -g3 -O2

#felix
ifdef LOG_COLLECTOR
    CFLAGS += -DLOG_COLLECTOR=$(LOG_COLLECTOR)
endif
#end
ifdef TC3262
    CFLAGS += -DTC3262=$(TC3262)
endif
ifdef TR181
    CFLAGS += -DTR181=$(TR181)
endif

#ifdef LAN_INTERFACE
 #   CFLAGS += -DLAN_INTERFACE=$(LAN_INTERFACE)
#endif

ifeq ($(CUSTOMER_MNF),y)
CFLAGS += -DCUSTOMIZE_MNF_TR069
endif 

#apply the MNF behavior to ADAM also
ifeq ($(CID561NC_ADAM),1)
CFLAGS += -DCUSTOMIZE_MNF_TR069
endif 

objs := $(SOURCES:.c=.o)
dirs := $(patsubst %, %_sub, $(SUBDIRS))
dirclean := $(patsubst %, %_clr, $(SUBDIRS))

#all: $(dirs) $(objs) O_TAR bin_prog fw
all: $(dirs) $(objs) O_TAR bin_prog
	@echo Build successufully...

%.o:%.c
	$(CC) $(CFLAGS) $(DEFS) $(INCLUDE) -c $< -o $@

$(dirs):
	make -C $(patsubst %_sub, %, $@) -f Makefile

O_TAR: $(objs)
ifdef O_TARGET

	$(LD) $(LDFLAGS) $(LDLIB) -r $(objs) $(LIBS) -o $(join lib, $(O_TARGET))

endif

bin_prog: clrbin $(bin_PROG)

clrbin: $($(join $@, _LIB))
ifdef bin_PROG
	rm -f $(bin_PROG)
endif


$(bin_PROG):

	$(CC) $(CFLAGS) $(DEFS) $(INCLUDE) $(LDFLAGS) $(LDLIBS) $($(join $@, _LIB)) -o $@ $($(join $@, _SOURCE))
	$(STRIP) $@


#test: clrtst $(test_PROG)

#clrtst:
#ifdef test_PROG
#	rm -f $(test_PROG)
#endif

#$(test_PROG):
#	$(CC) $(CFLAGS) $(DEFS) $(INCLUDE) $(LDFLAGS) $(LDLIBS) $($(join $@, _LIB)) -o $@ $($(join $@, _SOURCE))

#fw: clrfw $(fw_PROG)

#clrfw:
#ifdef fw_PROG
#	rm -f $(fw_PROG)
#endif

#$(fw_PROG):
#	$(CC) $(CFLAGS) $(DEFS) $(INCLUDE) $(LDFLAGS) $(LDLIBS) $($(join $@, _LIB)) -o $@ $($(join $@, _SOURCE))
	#$(CC) $(CFLAGS) $(DEFS) $(INCLUDE) $(LDFLAGS) $(LDLIBS) $($(join $@, _LIB)) -o $@ $($(join $@, _SOURCE))
	#$(STRIP) $@


clean: $(dirclean)
	rm -f $(objs)  $(patsubst %, lib%, $(O_TARGET)) $(bin_PROG) 
	#rm -f $(objs)  $(patsubst %, lib%, $(O_TARGET)) $(bin_PROG) $(test_PROG) $(fw_PROG)

$(dirclean):
	make -C $(patsubst %_clr, %, $@) -f Makefile clean

