#!/bin/sh
#
# snmpd.sh                     This script do a action of snmp
#

LANIF=br+
MULTI_SNMP_WAN_IF_INDEX="`rdcsman 0x001600a3 u32`"
RESET_SNMP="/var/run/reset_snmp_iptables"

if [ $MULTI_SNMP_WAN_IF_INDEX -gt 0 -a $MULTI_SNMP_WAN_IF_INDEX -ne 99 ]; then
    if [ $MULTI_SNMP_WAN_IF_INDEX -eq 1 ] ; then
        WANIF="`rdcsman 0x80010190 str`"
  
    elif [ $MULTI_SNMP_WAN_IF_INDEX -eq 2 ] ; then
        WANIF="`rdcsman 0x80010191 str`"
	
    elif [ $MULTI_SNMP_WAN_IF_INDEX -eq 3 ] ; then
   		WANIF="`rdcsman 0x80010192 str`"

    elif [ $MULTI_SNMP_WAN_IF_INDEX -eq 4 ] ; then
        WANIF="`rdcsman 0x80010193 str`"

    elif [ $MULTI_SNMP_WAN_IF_INDEX -eq 5 ] ; then
        WANIF="`rdcsman 0x80010194 str`"
	fi

else

#~     !!!! ($S_LOCAL_WAN_IF_NAME/str/)
WANIF="eth1"  #$dev_wan_interface	

#~~     if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~             if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS != 2) {
#~                           !!!! ($S_FAILOVER_WAN_IF_NAME/str/)
                       WANIF=eth1  #$dev_wan_interface
#~~             }
#~~             if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                    if ($S_FAILOVER_STATUS == 2) {
#~                                         !!!! ($S_FAILOVER_WAN_IF_NAME/str/)
                              SECOND_WANIF=eth1  #$dev_wan_interface
#~~                    }
#~~             }
#~~     }

fi

#~        !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
SNMP_WAN="192.168.123.254"
[ "$SNMP_WAN" == "" ] && SNMP_WAN="0.0.0.0"

SNMP_PORT="`rdcsman 0x001600a0 u32`"
if [ $SNMP_PORT -eq 0 ]; then
    SNMP_PORT=161;
fi

SNMP_TRAP_PORT=`rdcsman 0x80160009 u32`
if [ $SNMP_TRAP_PORT -eq 0 ]; then
    SNMP_TRAP_PORT=12823;
fi

start() {
	local err; err=0
	echo -n "start snmpd.sh ..."

#~~     if ($C_SNMP_LOCAL_ENABLE != 1) {
		iptables -t filter -A INPUT -i $LANIF -p udp --dport $SNMP_PORT -j DROP
#~~        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -A INPUT -i $LANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~        }
#~~     } else {
#~~        if ($C_SNMP_LAN_ACCESS_IP_ENABLE  == 1) {	
test $SNMP_WAN != "0.0.0.0" &&
#~                                                  !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
           iptables -t filter -A INPUT -i $LANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
           iptables -t filter -A INPUT -i $LANIF -p udp --dport $SNMP_PORT -j DROP
           echo "iptables -t filter -D INPUT -i $LANIF -s $SNMP_WAN -p udp --dport $SNMP_PORT -j ACCEPT " >> $RESET_SNMP
           echo "iptables -t filter -D INPUT -i $LANIF -p udp --dport $SNMP_PORT -j DROP " >> $RESET_SNMP
#~~        }    
#~~     }

#~~     if ($C_SNMP_REMOTE_ENABLE != 1) {
		iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP " >> $RESET_SNMP
#~~        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP " >> $RESET_SNMP
#~~        }
#~~                 if ($C_LOCAL_WAN_ALIAS_ENABLE == 1) {
#~~                     if ($C_LOCAL_WANTYPE == 16) { #3G
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }
#~~                     }
#~~                     if ($C_LOCAL_WANTYPE == 64) { #PPPoE
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }
#~~                     }
#~~                 }
#~~                 if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                     if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) { #connect
#~~                        if ($S_FAILOVER_STATUS == 2) { #connect
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j DROP
#~~                           if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                           }
#~~                        }
#~~                    }
#~~                 }
#~~     } else { 
#~~             if ($C_SNMP_WAN_ACCESS_IP != None) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP
        echo "iptables -t filter -D INPUT -i $WANIF -s $SNMP_WAN -p udp --dport $SNMP_PORT -j ACCEPT " >> $RESET_SNMP
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP " >> $RESET_SNMP
#~~                if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
		echo "iptables -t filter -D INPUT -i $WANIF -s $SNMP_WAN -p udp --dport $SNMP_TRAP_PORT -j ACCEPT " >> $RESET_SNMP
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP " >> $RESET_SNMP
#~~                }
#~~                 if ($C_LOCAL_WAN_ALIAS_ENABLE == 1) {
#~~                     if ($C_LOCAL_WANTYPE == 16) { #3G
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }
#~~                     }
#~~                     if ($C_LOCAL_WANTYPE == 64) { #PPPoE
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -A INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }
#~~                     }
#~~                 }
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_PORT -j ACCEPT
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j ACCEPT " >> $RESET_SNMP

#~~     if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
test $SNMP_WAN = "0.0.0.0" &&
		iptables -t filter -A INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j ACCEPT
        echo "iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j ACCEPT " >> $RESET_SNMP
#~~     }
#~~                    if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                           if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) { #connect
#~~                                  if ($S_FAILOVER_STATUS == 2) { #connect
#~                                                      !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j DROP
#~~                                     if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                      !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                                     }

test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j ACCEPT
#~~     if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
test $SNMP_WAN = "0.0.0.0" &&
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j ACCEPT
#~~     }
#~~                                  }
#~~                           }
#~~                    }
#~~             }
#~~     }
	
#~~     if ($C_MISC_SPI_MODE  == 1) {
			nat restart wanx spi
#~~     }
	return $err
}

stop() {
	local err; err=0
    echo -n "stop snmpd.sh ..."
	
	if [ -f $RESET_SNMP ];then
		(. $RESET_SNMP)
		rm -f $RESET_SNMP
	fi

#~~     if ($C_SNMP_LOCAL_ENABLE != 1) {
        iptables -t filter -D INPUT -i $LANIF -p udp --dport $SNMP_PORT -j DROP
#~~        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -D INPUT -i $LANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~        }
#~~     } else {
#~~        if ($C_SNMP_LAN_ACCESS_IP_ENABLE  == 1) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                                  !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
           iptables -t filter -D INPUT -i $LANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
           iptables -t filter -D INPUT -i $LANIF -p udp --dport $SNMP_PORT -j DROP
#~~        }
#~~     }

#~~     if ($C_SNMP_REMOTE_ENABLE != 1) {
        iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP
#~~        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~        }
#~~                 if ($C_LOCAL_WAN_ALIAS_ENABLE == 1) {
#~~                     if ($C_LOCAL_WANTYPE == 16) { #3G
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                         if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                         }
#~~                     }
#~~                     if ($C_LOCAL_WANTYPE == 64) { #PPPoE
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP 
#~~                         if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                         }
#~~                     }
#~~                 }
#~~             if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                    if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) { #connect
#~~                           if ($S_FAILOVER_STATUS == 2) { #connect
		iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j DROP 
#~~                              if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
		iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                              }
#~~                           }
#~~                    }
#~~             }
#~~     } else {
#~~             if ($C_SNMP_WAN_ACCESS_IP != None) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j DROP
#~~   if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~   }
#~~                 if ($C_LOCAL_WAN_ALIAS_ENABLE == 1) {
#~~                     if ($C_LOCAL_WANTYPE == 16) { #3G
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }
#~~                     }
#~~                     if ($C_LOCAL_WANTYPE == 64) { #PPPoE
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_PORT -j DROP
#~~                        if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                 !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i "eth2.2" -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -D INPUT -i "eth2.2" -p udp --dport $SNMP_TRAP_PORT -j DROP
#~~                        }  
#~~                     }
#~~                 }
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_PORT -j ACCEPT
#~~    if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport $SNMP_TRAP_PORT -j ACCEPT
#~~    }
#~~                    if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                           if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) { #connect
#~~                                  if ($S_FAILOVER_STATUS == 2) { #connect
#~                                                      !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_PORT -j ACCEPT &&
		iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_PORT -j ACCEPT
#~~                                      if ($C_SNMP_SECOND_TRAPPORT_ENABLE == 1) {
#~                                                      !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport $SNMP_TRAP_PORT -j ACCEPT &&
        iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport $SNMP_TRAP_PORT -j ACCEP
#~~                                      }
#~~                                  }
#~~                           }
#~~                    }
#~~             }
#~~     }

#~~     if ($C_MISC_SPI_MODE  == 1) {
			nat restart wanx spi
#~~     }
	return $err
}

usage() {
	echo "$0 [start|stop|restart|reload|config]"
	exit 1
}

# +++++++++++++++ main ++++++++++++++++++++++ 
[ -z "$1" ] && usage;

err=0

case "$1" in
	config)		;;
	start)		start;;
	stop)		stop;;
	reload)		;;
	restart)	stop; start;;
	*)		usage;;
esac
if [ $? = "0" ] ; then
	echo $0 $@ ok
else
	echo $0 $@ error
	err=1
fi

exit $err
